{ --------------------------------------------------------
   ਭ樯 ᭮ , ࠢ騩 ᠭ
   㫥 SeaField ꥪ⮬ GameField.
  --------------------------------------------------------
  Copyright(c) 1997 by Jassinskaja Jana, Jelena Kuznetsova
  -------------------------------------------------------- }
Unit SeaPlay;

interface
procedure SeaWarKuj;
procedure SeaWarInit;
procedure SeaWarDone;
procedure SeaWarPlay;

implementation

uses
  Crt, SeaField;

const
  PauseTime = 5000; { ६ প  ᮮ饭 }
  Key_Esc = #27;    {   ESC }

var
  Computer : ComputerFieldPtr;  {   }
  Human    : HumanFieldPtr;     {    祫 }
  HitsNumC,
  HitsNumH : byte;   { ᫮   ᥬ ࠡ; =20   }

procedure SeaWarKuj;
var i: integer;
begin
 textbackground(green);
 gotoxy(1, 1);
 for i:=1 to 80 do write(' ');
 for i:=1 to 24 do
 begin
  gotoxy( 1, i); write(' ');
  gotoxy(80, i); write(' ');
 end;
 gotoxy(1, 24);
 for i:=1 to 80 do write(' ');
 textbackground(black);
end;
{ ᮧ ஢   ⠭   ࠡ }
procedure SeaWarInit;
begin
SeaWarKuj;
  Randomize;        { 㧪  砩 ᥫ }
  New(Computer, Init(10, 8));
  New(Human, Init(50, 8));

  { ⠭ ࠡ }
  Computer^.SetUpField;
  Human^.SetUpField;

  { ᫮  ⠢  0 }
  HitsNumC := 0;
  HitsNumH := 0;
end;

{ ᢮   }
procedure SeaWarDone;
begin
  Dispose(Computer, Done);
  Dispose(Human, Done);
end;

{ 祫  ᢮ 室
  頥 FALSE  뢠 ணࠬ
     祫 }
function HumanMotion : boolean;
var
  X, Y, Status : byte;   { X, Y -  न;
                           Status -   ⪨    }
  Ch : char;          {  ⠥ ᨬ   }
  Code : integer;   { ६ ६ ᯮ㥬 
                      ८ࠧ   ᫮ (Val) }
begin
  { 塞  室      ஬ }
  repeat
    { ⨬ ப  뢮 ᮮ饭   ࠭ }
    GotoXY(32, 20); ClrEol;
    GotoXY(3, 3); ClrEol;
    Write(' 室 - X : ');

    { ⨬   -       }
    while KeyPressed do Ch := Readkey;
    {  ⥯    0-9  ESC }
    repeat
      Ch := Readkey;        { ⠥ ᨬ   }
    until Ch in ['0'..'9', Key_Esc];

    { ᫨  ESC,  室  ணࠬ }
    if Ch = Key_Esc then begin
      HumanMotion := FALSE;
      exit;
    end
    else
      Val(Ch, X, Code);     { ८ࠧ㥬 ᨬ '0'-'9'   }
    Write(X);
    Write('    Y : ');

    { ⥯  न Y }
    repeat
      Ch := Readkey;
    until Ch in ['0'..'9', Key_Esc];
    if Ch = Key_Esc then begin
      HumanMotion := FALSE;
      exit;
    end
    else
      Val(Ch, Y, Code);
    Writeln(Y);

    { ஢塞  न⠬ 祩   }
    Status := Computer^.GetCell(X, Y);
    GotoXY(32, 20); ClrEol;

    case Status of
      { ᫨ ⠬  ࠡ,  !!!!! -  }
      Ship1, Ship2, Ship3, Ship4 : begin
        Inc(HitsNumH);     { 㢥稬 ᫮ ⮯ ⥩ }
        Writeln('      ! ! !');
        Computer^.PutOnePart(X, Y, Hit+Status); { ⮯   }
      end;
      BusyCell, FreeCell : begin
        {  ᫨ 祩 ,  .....  }
        Write('     ! ! !');
        { ⬥⨬   ५ﭭ ⮡ 2 ࠧ  ५  1  }
        Computer^.SetCell(X, Y, PastMove);
      end;
      {   ᫨  ५塞  㦥 ⮯ ࠡ  㤠
        㤠 㦥 ५﫨,  ..... .... 㯮 }
      PastMove, Hit..255 : Write('   !');
    end;
    { 㥬   }
    Computer^.DrawField;
    Delay(PauseTime);             {   }
    {   ⮯    ࠡ  ? }
    if HitsNumH = 20 then begin
      {  ࠧ ⮯,   ࠧ }
      GotoXY(32, 20); ClrEol;
      Writeln('  !');
      HumanMotion := FALSE;
      Delay(PauseTime);
      exit;            { 稢 ணࠬ }
     end;
  { ᫨ 뫨 ,  ᭮  室 }
  until not (Status in [Ship1, Ship2, Ship3, Ship4]);
end;

{ 室 :
  頥 FALSE  室  ணࠬ
      }
function ComputerMotion : boolean;
var
  X, Y : byte;      { न ⪨ }
  Status : byte;    {   ⪨ (X, Y)   祫 }
begin
  {  ५塞      ஬ }
  repeat
    GotoXY(32,20); ClrEol;
    { 室  न  ५ }
    repeat
      X := Random(FieldSize+1);
      Y := Random(FieldSize+1);
      Status := Human^.GetCell(X, Y); { ஢塞,  ५  
                                          ⮣ }
    until not (Status in [BusyCell, PastMove, Hit..255, NotAvail]);

    GotoXY(3, 3); ClrEol;
    Write(' 室 - X : ', X, '    Y : ',Y);
    GotoXY(32, 20); ClrEol;

    case Status of
      Ship1, Ship2, Ship3, Ship4 : begin
        { ᬮ !     ࠡ! }
        Inc(HitsNumC);         { 㢥稬 横 ᫠  ࠡ }
        Writeln('  ! ! !');
        Human^.PutOnePart(X, Y, Hit+Status); { 䨪㥬  }
      end;
      FreeCell : begin
                   { ....   㬥 ! }
                   Write('  ! ! !');
                   Human^.SetCell(X, Y, PastMove); { ⬥⨬ ஬   }
                 end;
    end;
    Human^.DrawField;   { 㥬  祫 }
    Delay(PauseTime);
    if HitsNumC = 20 then begin
      { ஢ਬ    ? }
      GotoXY(32, 20); ClrEol;
      Writeln('  !');
      ComputerMotion := FALSE;
      Delay(PauseTime);
      exit;             { ᫨   멤  楤 }
    end;
  { ᫨ 뫨   ࠡ,    室 }
  until not (Status in [Ship1, Ship2, Ship3, Ship4]);
end;

procedure SeaWarPlay;
begin
  { 뢮  ࠭ ஢  }
  Computer^.DrawField;
  Human^.DrawField;

  { 뢮    }
  TextColor(Yellow);
  GotoXY(18, 6); Write('');
  GotoXY(59, 6); Write('');
  TextColor(LightGray);

  { ࠥ      ESC  -   }
  while TRUE do begin
    if not HumanMotion then exit;
    if not ComputerMotion then exit;
  end;
end;

end.