package ruum;
import java.awt.Graphics;
public class Punkt extends Ese{
public int x, y, z;
public Punkt(){x=0; y=0; z=0;}
public Punkt(int ux, int uy, int uz){
 x=ux; y=uy; z=uz;
}
public Punkt(Punkt uk){
x=uk.x; y=uk.y; z=uk.z;}
public void liida(int ux, int uy, int uz){
 x+=ux; y+=uy; z+=uz;
}
public void liida(Punkt uk){
 x+=uk.x; y+=uk.y; z+=uk.z;
}

public static Punkt liida(Punkt u1, Punkt u2){
Punkt u=new Punkt();
 u.x=u1.x+u2.x;
 u.y=u1.y+u2.y;
 u.z=u1.z+u2.z;
 return u;
}

public void lahuta(int ux, int uy, int uz){
 x-=ux; y-=uy; z-=uz;
}

public void lahuta(Punkt uk){
 x-=uk.x; y-=uk.y; z-=uk.z;
}

public static Punkt lahuta(Punkt u1, Punkt u2){
Punkt u=new Punkt();
 u.x=u1.x-u2.x;
 u.y=u1.y-u2.y;
 u.z=u1.z-u2.z;
 return u;
}

public void korruta(double d){
 x=(int)Math.round(d*x);
 y=(int)Math.round(d*y);
 z=(int)Math.round(d*z);
}

public static Punkt korruta(Punkt p, double d){
Punkt u=new Punkt();
 u.x=(int)Math.round(d*p.x);
 u.y=(int)Math.round(d*p.y);
 u.z=(int)Math.round(d*p.z);
 return u;
}

public static Punkt keera(Punkt tp, Punkt ip, float xz, float yz, float xy){
 Punkt kp=Punkt.lahuta(ip, tp);
 Punkt up=(Punkt)kp.clone();
 if(xz!=0){
  up.x=(int)Math.round(kp.x*Math.cos(xz)+kp.z*Math.sin(xz));
  up.z=(int)Math.round(-kp.x*Math.sin(xz)+kp.z*Math.cos(xz));
 }
 if(xy!=0){
  up.x=(int)Math.round(kp.x*Math.cos(xy)+kp.y*Math.sin(xy));
  up.y=(int)Math.round(-kp.x*Math.sin(xy)+kp.y*Math.cos(xy));
 }
 if(yz!=0){
  yz=-yz;
  up.y=(int)Math.round(kp.y*Math.cos(yz)+kp.z*Math.sin(yz));
  up.z=(int)Math.round(-kp.y*Math.sin(yz)+kp.z*Math.cos(yz));
 }
 up=Punkt.liida(up, tp);
 return up;
}

public Ese keera(Punkt p, float xz, float yz, float xy){
 return Punkt.keera(p, this, xz, yz, xy);
}

public void joonista(Graphics g){
g.drawLine(Math.round(x*grtegur/z), Math.round(-y*grtegur/z),
           Math.round(x*grtegur/z), Math.round(-y*grtegur/z));}
public void joonista(Graphics g, Punkt p){
 Punkt up=Punkt.lahuta(this, p);
 up.joonista(g);
}

public double kaugus(Punkt p){return Punkt.kaugus(p, this);}

public static double kaugus(Punkt p1, Punkt p2){
  return(Vektor.pikkus(Punkt.lahuta(p2, p1)));
}

public String toString(){
 return x+" "+y+" "+z;}

public Object clone(){
Punkt u=new Punkt();
 u.x=x;
 u.y=y;
 u.z=z;
 return u;
}
}
