 uses graph, crt;
type
   punkt=record
     x, y: real;
   end;
   viienurk_ringina=object
     nurk:array[1..5] of punkt;
     procedure loo(x1, y1, x2, y2, x3, y3,x4,y4,x5,y5: real);
     procedure keera(kraad:real);
     procedure joonista(x, y: integer);
     procedure joonista_keeratult(x, y:integer; kraad: real);
     procedure ring;

   end;

procedure viienurk.loo(x1, y1, x2, y2, x3, y3,x4,y4,x5.y5: real);
begin
  nurk[1].x:=x1; nurk[1].y:=y1;
  nurk[2].x:=x2; nurk[2].y:=y2;
  nurk[3].x:=x3; nurk[3].y:=y3;
  nurk[4].x:=x4; nurk[4].y:=y4;
  nurk[5].x:=x5; nurk[5].y:=y5;

end;

procedure viienurk.keera(kraad: real);
 var i: integer;
 abi, radiaan:real;
begin

 radiaan:=kraad*Pi/180;
 for i:=1 to 5 do
 begin
   abi:=nurk[i].x;
   nurk[i].x:=nurk[i].x*cos(radiaan)-nurk[i].y*sin(radiaan);
   nurk[i].y:=abi*sin(radiaan)+nurk[i].y*cos(radiaan);
 end;
end;

procedure viienurk.joonista(x, y: integer);
 var i: integer;
begin
 for i:=1 to 3 do
     line(x+round(nurk[i].x),   y+round(nurk[i].y),
          x+round(nurk[i+1].x), y+round(nurk[i+1].y));
 line(x+round(nurk[3].x), y+round(nurk[3].y),
      x+round(nurk[1].x), y+round(nurk[1].y));
end;

procedure viienurk.joonista_keeratult(x, y: integer; kraad: real);
 var abikolmnurk: kolmnurk;
begin
 abiviienurk:=self;
 abiviienurk.keera(kraad);
 abiviienurk.joonista(x, y);
end;

var nurk, kraad, raadius: real;
d, m, keskx, kesky: integer;
nn1: viienurk;
begin
 d:=detect; initgraph(d, m, '');
 nurk:=0;kraad:=0; keskx:=300; kesky:=100; raadius:=50;
 nn1.loo(-30, -20, 30, -20, 0, 0 );

 repeat
  cleardevice;
  nn1.joonista_keeratult(100, 100, kraad);
  delay(25);
  kraad:=kraad+40;
 until keypressed;
 readkey;
 repeat
  cleardevice;
  nn1.joonista_keeratult(round(keskx+raadius*sin(nurk)),
          round(kesky+raadius*cos(nurk)), kraad);
  delay(25);
  nurk:=nurk+0.1;
  kraad:=kraad-20;
 until keypressed;
 closegraph;
end.

