uses graph, crt;
type
   punkt=record
     x, y: real;
   end;
   nelinurk=object
     nurk:array[1..4] of punkt;
     procedure loo(x1, y1, x2, y2, x3, y3, x4, y4: real);
     procedure keera(kraad:real);
     procedure joonista(x, y: integer);
     procedure joonista_keeratult(x, y:integer; kraad: real);
   end;

procedure nelinurk.loo(x1, y1, x2, y2, x3, y3, x4, y4: real);
begin
  nurk[1].x:=x1; nurk[1].y:=y1;
  nurk[2].x:=x2; nurk[2].y:=y2;
  nurk[3].x:=x3; nurk[3].y:=y3;
  nurk[4].x:=x4; nurk[4].y:=y4;
end;

procedure nelinurk.keera(kraad: real);
 var i: integer;
 abi, radiaan:real;
begin
 radiaan:=kraad*Pi/180;
 for i:=1 to 4 do
 begin
   abi:=nurk[i].x;
   nurk[i].x:=nurk[i].x*cos(radiaan)-nurk[i].y*sin(radiaan);
   nurk[i].y:=abi*sin(radiaan)+nurk[i].y*cos(radiaan);
 end;
end;

procedure nelinurk.joonista(x, y: integer);
 var i: integer;
begin
 for i:=1 to 4 do
     line(x+round(nurk[i].x),   y+round(nurk[i].y),
          x+round(nurk[i+1].x), y+round(nurk[i+1].y));
 line(x+round(nurk[3].x), y+round(nurk[3].y),
      x+round(nurk[1].x), y+round(nurk[1].y));

{ line(x+round(nurk[4].x), y+round(nurk[4].y),
      x+round(nurk[1].x), y+round(nurk[1].y));  }

end;

procedure nelinurk.joonista_keeratult(x, y: integer; kraad: real);
 var abinelinurk: nelinurk;
begin
 abinelinurk:=self;
 abinelinurk.keera(kraad);
 abinelinurk.joonista(x, y);
end;

var nurk, kraad, raadius: real;
d, m, keskx, kesky: integer;
nn1: nelinurk;
begin
 d:=detect; initgraph(d, m, '');
 nurk:=0;kraad:=0; keskx:=300; kesky:=100; raadius:=50;
 nn1.loo(-10, -5, 10, -5, 10, 5, -10, 5);

 repeat
  cleardevice;
  nn1.joonista_keeratult(100, 100, kraad);
  delay(25);
  kraad:=kraad+40;
 until keypressed;
 readkey;
 repeat
  cleardevice;
  nn1.joonista_keeratult(round(keskx+raadius*sin(nurk)),
          round(kesky+raadius*cos(nurk)), kraad);
  delay(25);
  nurk:=nurk+0.1;
  kraad:=kraad-20;
 until keypressed;
 closegraph;
end.

