uses graph, crt;
type
   punkt=record
     x, y: real;
   end;
   kolmnurk=object
     nurk:array[1..3] of punkt;
     procedure loo(x1, y1, x2, y2, x3, y3: real);
     procedure keera(kraad:real);
     procedure joonista(x, y: integer);
     procedure joonista_keeratult(x, y:integer; kraad: real);
   end;

procedure kolmnurk.loo(x1, y1, x2, y2, x3, y3: real);
begin
  nurk[1].x:=x1; nurk[1].y:=y1;
  nurk[2].x:=x2; nurk[2].y:=y2;
  nurk[3].x:=x3; nurk[3].y:=y3;
end;

procedure kolmnurk.keera(kraad: real);
 var i: integer;
 abi, radiaan:real;
begin
 radiaan:=kraad*Pi/180;
 for i:=1 to 3 do
 begin
   abi:=nurk[i].x;
   nurk[i].x:=nurk[i].x*cos(radiaan)-nurk[i].y*sin(radiaan);
   nurk[i].y:=abi*sin(radiaan)+nurk[i].y*cos(radiaan);
 end;
end;

procedure kolmnurk.joonista(x, y: integer);
 var i: integer;
begin
 for i:=1 to 2 do
     line(x+round(nurk[i].x),   y+round(nurk[i].y),
          x+round(nurk[i+1].x), y+round(nurk[i+1].y));
 line(x+round(nurk[3].x), y+round(nurk[3].y),
      x+round(nurk[1].x), y+round(nurk[1].y));
setcolor(green);
end;

procedure kolmnurk.joonista_keeratult(x, y: integer; kraad: real);
 var abinelinurk: kolmnurk;
begin
 abinelinurk:=self;
 abinelinurk.keera(kraad);
 abinelinurk.joonista(x, y);
end;

var nurk, kraad, raadius: real;
d, m, keskx, kesky: integer;
kn1: kolmnurk;
begin
 d:=detect; initgraph(d, m, '');
 nurk:=0;kraad:=0; keskx:=300; kesky:=100; raadius:=80;
 kn1.loo(- 15, -26, 10, -10, 15, 20);

 repeat
  cleardevice;
  kn1.joonista_keeratult(100, 100, kraad);
  delay(25);

  kraad:=kraad-10;
 until keypressed;
 readkey;
 repeat
  cleardevice;
  kn1.joonista_keeratult(round(keskx+raadius*sin(nurk)),
          round(kesky+raadius*cos(nurk)), kraad);
  delay(25);
  nurk:=nurk+0.01;
  kraad:=kraad+10;
 until keypressed;
 closegraph;
end.

