#!/usr/bin/perl

$guestbookurl = "http://minitorn.tpu.ee/~jaagup/kool/pascal/book/raamat.html";
$guestbookreal = "/home/jaagup/public_html/kool/pascal/book/raamat.html";
$guestlog = "/home/jaagup/public_html/kool/pascal/book/guestlog.html";
$cgiurl = "http://minitorn.tpu.ee/~jaagup/kool/pascal/book/guestbook/raamat.pl";
$date_command = "/bin/date";

# Set Your Options:
$mail = 0;              # 1 = Yes; 0 = No
$uselog = 1;            # 1 = Yes; 0 = No
$linkmail = 1;          # 1 = Yes; 0 = No
$separator = 1;         # 1 = <hr>; 0 = <p>
$redirection = 0;       # 1 = Yes; 0 = No
$entry_order = 1;       # 1 = Newest entries added first;
                        # 0 = Newest Entries added last.
$remote_mail = 0;       # 1 = Yes; 0 = No
$allow_html = 1;        # 1 = Yes; 0 = No
$line_breaks = 0;	# 1 = Yes; 0 = No

$date = `$date_command +"%A, %B %d, %Y at %T (%Z)"`; chop($date);
$shortdate = `$date_command +"%D %T %Z"`; 
for($di=0; $di<9; $di++){chop($shortdate);}

# Get the input
#read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
$buffer=<STDIN>;
# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   if ($allow_html != 1) {
      $value =~ s/<([^>]|\n)*>//g;
   }

   $FORM{$name} = $value;
}

# Print the Blank Response Subroutines
&no_comments unless $FORM{'comments'};
#&no_name unless $FORM{'realname'};

# Begin the Editing of the Guestbook File
open (FILE,"$guestbookreal") || die "Can't Open $guestbookreal: $!\n";
@LINES=<FILE>;
close(FILE);
$SIZE=@LINES;

# Open Link File to Output
open (GUEST,">$guestbookreal") || die "Can't Open $guestbookreal: $!\n";

for ($i=0;$i<=$SIZE;$i++) {
   $_=$LINES[$i];
   if (/<!--begin-->/) { 

      if ($entry_order eq '1') {
         print GUEST "<!--begin-->\n";
      }
   
      if ($line_breaks == 1) {
         $FORM{'comments'} =~ s/\cM\n/<br>\n/g;
      }

      print GUEST "<b>$FORM{'comments'}</b><br>\n";


      if ($separator eq '1') {
         print GUEST " - $shortdate<hr>\n\n";
      }
      else {
         print GUEST " - $date<p>\n\n";
      }

      if ($entry_order eq '0') {
         print GUEST "<!--begin-->\n";
      }

   }
   else {
      print GUEST $_;
   }
}

close (GUEST);

# Log The Entry

if ($uselog eq '1') {
   &log('entry');
}


#########
# Options


# Print Out Initial Output Location Heading
if ($redirection eq '1') {
   print "Location: $guestbookurl\n\n";
}
else { 
   &no_redirection;
}

#######################
# Subroutines

sub no_comments {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Tekst puudub</title></head>\n";
   print "<body bgcolor=\"#FF0000\"><h1>Jtsid teksti kirjutamata!</h1>\n";
   print "Kirjuta uuesti\n ";
   print "<form method=POST action=\"$cgiurl\">\n";
   print "<textarea name=\"comments\" COLS=60 ROWS=4></textarea><p>\n";
   print "<input type=submit value=saada> * <input type=reset value=kustuta></form><hr>\n";
   print "Vi vaata <a href=\"$guestbookurl\">teiste juttu</a>.";
   print "\n</body></html>\n";

   # Log The Error
   if ($uselog eq '1') {
      &log('no_comments');
   }

   exit;
}


# Log the Entry or Error
sub log {
   $log_type = $_[0];
   open (LOG, ">>$guestlog");
   if ($log_type eq 'entry') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate]<br>\n";
   }
   elsif ($log_type eq 'no_name') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: No Name<br>\n";
   }
   elsif ($log_type eq 'no_comments') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: No ";
      print LOG "Comments<br>\n";
   }
}

# Redirection Option
sub no_redirection {

   # Print Beginning of HTML
   print "Content-Type: text/html\n\n";
   print "<html><head><title>Tnamine</title></head>\n";
   print "<body bgcolor=\"#00FF00\"><h1>Aith sissekande eest!</h1>\n";

   # Print Response
   print "Sinu jutt judis kaebuste, ettepanekute, soovituste\n";
   print "mrkuste ja muude thelepanekute raamatusse.<hr>\n";
   print "Arvuti andmetes saatsid sa sellise teksti:<p>\n";
   print "<b>$FORM{'comments'}</b><br>\n";


   print " - $date<p>\n";

   # Print End of HTML
   print "<hr>\n";
   print "<a href=\"$guestbookurl\">Raamatusse tagasi</a>\n";         
   print "- Kui ei ne oma juttu, vajuta <tt>Reloadile</tt>\n";
   print "</body></html>\n";

   exit;
}

